﻿using CallCenter.Caches;
using CallCenter.Calls;
using CallCenter.Notifications;
using CallCenter.Realtimes;
using MediatR;

namespace CallCenter.Application.Handlers
{
    public class QueueVisitorToGroupBusyNotificationHandler:INotificationHandler<QueueVisitorToGroupBusyNotification>
    {
        private readonly ICallCacheManager _callCacheManager;
        private readonly IRealtimeService _realtimeService;
        public QueueVisitorToGroupBusyNotificationHandler( ICallCacheManager callCacheManager, IRealtimeService realtimeService)
        {
            _callCacheManager = callCacheManager;
            _realtimeService = realtimeService;
        }

        public async Task Handle(QueueVisitorToGroupBusyNotification notification, CancellationToken cancellationToken)
        {
            await _realtimeService.CallQueueAsync(_callCacheManager.GetCallQueueList(), cancellationToken);
        }
    }
}
